v3.11.0 - 06/07/2026
	Relaxed the check to detect inward shifted tracks ahead of offering a shift outwards

v3.10.0 - 08/02/2026
	Added support for re-reading sectors with errors in a track range
	Made a number of changes for maintainability
	Fixed a menu item tooltip

v3.9.4 - 17/09/2025
	Corrected the title of the file chooser dialog when saving the sector grid to a PNG file
	Improved the abort mechanism
	Increased the spacing between sector cells proportionally to zoom level
	Made a number of changes for maintainability
	64-bit versions of avrdude are now included in 64-bit Windows packages

v3.9.3 - 25/04/2025
	Fixed failure handling holistically
	Updated copyright date in the about dialog
	Fixed changelog date for v3.9.2

v3.9.2 - 11/04/2025
	Correctly handle failures when "Format II" returns an error

v3.9.1 - 20/12/2024
	Reworded the warpsave menu item under the "Special" menu
	By default use the font "Monospace 10" for the logging TextView under Windows

v3.9.0 - 10/08/2024
	Select the last opened file, if any, in the file chooser dialog to open D64 files
	Enable the "Special" menu in the 40-track version of the client, excluding the BAM-based strategy as it's not standardised
	Implemented the detection of loops in the directory t/s chain, including logging the condition

v3.8.12 - 05/11/2023
	Added a counter of accessible sector errors in the disk dumping tab
	When warpsaving to D64 also check if tracks need shifting outwards and offer to do so
	Check if tracks require shifting inwards or outwards also when loading a D64 for re-reads

v3.8.11 - 03/10/2023
	The file chooser dialog for opening D64 files now also shows the count of sector errors (including accessible ones) when a file is selected
	The statusbar now also shows the count of accessible sector errors when a D64 file is loaded for re-reads
	Prevent the creation of multiple copies of the same dialogs under macOS
	When expanding the file chooser dialog for opening D64 files the vertical scrollbar is not expanded any longer

v3.8.10 - 21/05/2023
	Added the option to zoom the drawing areas in the main window
	Added the option to set the font of the logging TextView
	Upon restarting, the main window is now repositioned where it had previously been

v3.8.9 - 25/09/2022
	Limited the characters that can be used for disk name and ID when formatting disks
	Implemented the option to perform firmware updates under macOS too
	Ask for user confirmation before quitting the application
	Generalised a few checks that are looking for 0xA0 in strings

v3.8.8 - 28/06/2022
	Fixed unnecessary logging attempts that were causing GLib warnings
	Set the sector interleave to 5 for restoring D64 images to disk under Linux
	Changed the way CTRL + mouse clicks are handled
	Directory listing previews that are part of the file chooser dialogs are never partially hidden by the vertical scrollbar any longer
	Fixed a global sector index validation check
	Fixed the fontset used in all directory listings
	Fixed the logic that detects SCRatched files when generating a directory listing (was broken by the 0 char replacement in v3.8.7)

v3.8.7 - 07/11/2020
	Directory listing previews that are part of the file chooser dialogs are now scrollable
	Any 0s occuring in a disk's name/ID (used e.g. to truncate the directory listing) or in a filename are now consistently replaced with '@'s
	A tooltip with t/s values is now displayed when the mouse pointer hovers on a sector, along with the name of the file it belongs to, if applicable
	Added tooltips for sector navigation buttons within the sector content explorer
	After dumping a disk or re-reading all sectors, the count of total errors is also shown in the statusbar
	After dumping a disk or re-reading all sectors, the count of errors on the first sector of each PRG file is also shown in the statusbar
	Added the option to attempt fixing only track 18 errors AND first sector of ALL PRG files (in alpha stage)

v3.8.6 - 28/07/2020 (FIRMWARE UPDATE TO VERSION 2.4 IS OPTIONAL)
	Added the option to export sector grid contents to PNG
	Added the option to dump a 1541 or 1571 drive's ROM (requires the firmware update)
	The current path for D64/PRG files is also updated when path+filename are typed into the relevant filechooser directly
	Added accelerators to settings menu entries
	When saving individual D64 files, directory contents are shown in a preview image within the file chooser dialog

v3.8.5 - 14/03/2020 (FIRMWARE UPDATE TO VERSION 2.3 IS OPTIONAL)
	The drive code for sector retries now gives up automatically if a sector can't be found, i.e. there's no need to unlatch the drive to proceed (requires the firmware update)
	Sector read retries are not performed when a dumped disk appears to be unformatted
	Sector contents and directory listing are now cleared when formatting a disk
	Added accelerators: ALT+{n} to switch between notebook tabs, and ALT+a to abort the disk operation currently in progress

v3.8.4 - 02/02/2020
	A preview is now displayed while the directory listing is being transmitted
	Added some logic to recognize unformatted disks
	Changed the logic used to detect when a disk uses more than 35 tracks
	Shift up to 5 tracks when a disk is written by a misaligned drive, instead of just 4
	Only attempt shifting of disks written by misaligned drives if there are "missing sync" errors
	The setting "Retry sectors once per pass" also applies to dir track retries
	Added the setting to let users enable/disable the generation of MD5 digest files
	Fixed the logic affecting a number of application settings
	Changed the default values of a few settings, in order to facilitate cooperation with "The Transfer Team"

v3.8.3 - 10/10/2019
	Fixed a bug for which D64 images with error info but no block errors could not be restored

v3.8.2 - 05/10/2019
	The main window title is updated with the name of the disk image when restoring a D64 to a physical disk

v3.8.1 - 22/09/2019
	Added the setting to let users change the sector grid background color, with CTRL + mouse click over the emty space
	Added the setting to let users change the position of special flags (i.e. "T18", "T18+", "BAM") in output filenames
	Added the setting to let users double the image size when exporting the directory listing to PNG
	When reading the firmware version from the hardware, advise users whether it's current or they should upgrade/downgrade

v3.8 - 16/06/2019
	When browsing for D64 files, directory contents are shown in a preview image within the file chooser dialog
	An attempt at decoding the directory listing is made also if BAM/dir track data appear to be in track 19 or 20
	Added drag'n'drop of D64 files for re-read purposes
	Directory listings (browsing preview, navigation, PNG export) are red if BAM/dir track data are retrieved from track 19 or 20
	If the ownership of a sector is undetermined, or the sector belongs to the BAM/dir track, "N/A" is shown as its owner's filename
	Added the setting to let users display sector contents as PETSCII too
	The number of sector read retries can now be set to 0, e.g. when users desire that no additional reads are attempted once a disk is Warp imaged to D64
	When retrying a sector its contents and status are not replaced if the new read is impaired by a worse or same-severity error
	The allocated sector map is also shown when dumping just sectors in track 18, track 18 and first sector of each PRG, or based on BAM contents

v3.7 - 24/05/2019
	Fixed so that old dir entries won't show up while reading dir is in progress and the user activates dir navigation controls
	Fixed so that when clicking on the white area immediately below the last sector in a track a ghost sector's contents won't be displayed
	Changed the color used for data checkbyte failures to a different shade of yellow, easier to tell apart from green
	Users are not shown the warning about a disk using tracks beyond 35 if 0xA0 is found in t/s 18/0 at offset 0xAB
	The relevant notebook page is now on top when using accelerators for disk imaging/retrying and directory listing
	Added a menu item for listing directory contents, whose accelerator is F7
	Added the setting to show/hide SCRatched files in the directory listing of a D64 file (generated when the file is loaded or saved)
	Changed so that users are required to press CTRL when clicking on a sector to display its contents
	Changed so that "max errors" can be set up to 1000, rather than just 600
	Swapped the position and role of the buttons within the Yes/No confirmation dialog
	Added an overall status icon in the bottom right corner of the application window, for improved feedback within noisy environments
	When reading dir fails, the directory listing is reset so the "READING DIR..." message goes away
	When showing sector contents, an attempt is made to find out which file the sector belongs to
	Changed to persist "max errors", "read retries", and "outermost track" values, by means of the configuration file
	Users can now inspect sector contents without having to first close the "Sector contents" window in between inspections
	Sector contents are always displayed, regardless of the block error type
	Added a menu item for exporting the current directory listing to a PNG file, whose accelerator is SHIFT+F7
	When F7 is pressed, the directory listing is reset ahead of bringing its notebook page on top

v3.6 - 11/05/2019
	Fixed the implementation logic behind the setting "Retry sectors once per pass" as it was inverted, and made it active by default
	Fixed the "Warpsave to disk" option: the in-memory disk image was accidentally blanked out before being saved to disk

v3.5 - 12/04/2019
	Changed accelerators from ALT+F{n} to SHIFT+F{n} for retries as the former are often used for screen-related functionalities
	Allow up to 100 read retries per sector, instead of just 25, in case of sectors with read errors
	Also show the FDC code (a.k.a. block error value) within the sector contents window
	Added the setting to let users decide whether or not a confirmation is required before an existing disk image is overwritten, if auto-naming is enabled
	Added the setting to let users decide whether a sector is retried once per pass or all retries should be exhausted for a single sector before the next one is retried
	Show the last loaded/saved D64 file name in the application's title bar
	Ensure that the focus sticks to the "Warpsave to D64" and "Directory" buttons, so that the SPACE key can be used as an accelerator
	Scrollbar updates take effect immediately on the directory listing

v3.4 - 15/12/2018
	When auto-naming is enabled, users are prompted to select the destination folder
	Added a menu item to let users select the folder where disk images are saved to and loaded from
	Let users decide whether or not to append the disk name to an image name, if auto-naming is enabled
	Enabled page increments for the directory scrollbar (i.e. when users click in the empty area of the scrollbar)
	Added the setting to let users set the disk side letter case, A/B or a/b, through the "Application settings" window
	Added the setting to let users set the PRG file extension according to the disk image one, PRG or prg, through the "Application settings" window

v3.3 - 09/12/2018
	Added a vertical scrollbar for the directory listing
	Added the setting to display sector contents, by clicking on a sector
	Added the setting to let users load disk images without errors too, in order to inspect sector contents
	The application notifies users whether tracks beyond 35 appear to be in use also when loading a disk image or re-reading sectors with errors
	The application notifies users whether a dump or disk image appears to be side B of a 1571 disk
	Notifications can be enabled or disabled through the "Application settings" window

v3.2 - 30/11/2018
	After shifting tracks, if the BAM sector contains errors, the application doesn't check whether inaccessible tracks are in use
	Maximum sector read errors can be set to 0, so that no retries are attempted at first-pass
	Sectors in inaccessible tracks are now marked with error code BLK_ERR_NOT_READY (0x0F) when creating new disk images
	Sectors in inaccessible tracks are not fetched during re-reads
	If there's a sector read error, the t/s link used to detect misaligned disks is not used
	If the outermost track value is set to 2 or more, inaccessible sectors are consistently marked with BLK_ERR_NOT_READY (0x0F) when creating new disk images
	Users can now choose the default extension for new disk images, D64 or d64, through the "Application settings" window
	Implemented a stricter sanitization of the suggested disk name when saving disk images
	Changed the directory decoder to also shows SCR(atched) files when dumping disks and opening disk images for re-reads
	A separate log file is created/updated when re-reading sectors with errors, instead of overwriting the original one
	When dumping a whole disk, or loading an image for re-reads, allocated sectors are marked with a small circle (35 track binary only)
	A disk is always initialized ahead of reading the directory listing (via DOS) and any group of sectors, to work with a strong reference
	When dumping a whole disk, the application advises users whether tracks beyond 35 appear to be in use (35 track binary only)
	The application also remembers the folder from where the last disk image was loaded

v3.1 - 19/10/2018
	The sector data checksum value is also logged when a read sector passes the GCR decoding
	Redesigned the sector retrying mechanism for dumping disks
	Added the setting to load an existing D64 with block error info, to retry reading sectors with errors
	Added the setting to retry reading all sectors with errors
	The directory listing is generated as soon as track 18 is read in, for full disk and track 18 dumping modes
	Shortened communication timeouts under Windows, to speed up single sector access
	Rewritten the strategy to dump track 18+, to reduce the workload of the stepper motor
	Added the setting to retry reading all sectors with errors on track 18 only

v3.0 - 12/10/2018 (FIRMWARE UPDATE TO VERSION 2.2 IS REQUIRED)
	Updated with the latest version of the IECHost firmware
	D64 files are saved inclusive of the block error info when dumping disks, if there are errors
	MD5 digests are saved along with D64 files when dumping disks
	Added the setting to dump just track 18 to a D64 file, useful to recover the directory listing of a damaged disk
	Added the setting to dump just track 18 and the first sector of each PRG file (also referred to as "track 18+") to a D64 file
	Added the setting to dump just allocated sectors, as per BAM contents, to a D64 file
	The current directory listing is wiped immediately before a new one is read
	Added the setting to select the outermost track when dumping disks for disks written with badly misaligned drives
	Added the detection of inaccessible tracks for disks written with badly misaligned drives
	Added the setting to automatically shift track data for disks written with badly misaligned drives
	Added the setting to (hard) reset the IEC bus
	Replaced the setting to pre-seek track 18 with the one to pre-initiate the disk, before dumping
	The directory listing is generated after dumping a disk
	Additional safe characters are allowed in file and disk names when saving them

v2.18 - 30/09/2018 (FIRMWARE UPDATE TO VERSION 2.1 IS OPTIONAL)
	Updated with the latest version of the IECHost firmware
	Fixed the file type description for D64 files when restoring disk images
	Program info and configuration filename are shown in the logging pane at startup

v2.17 - 15/09/2018
	An event is also logged if the transmission checkbyte check fails
	An event is also logged if sector retry attempts are exausted when retrying sectors

v2.16 - 13/09/2018
	The outcome of sector retry attempts is also logged

v2.15 - 11/09/2018 (FIRMWARE UPDATE TO VERSION 2.0 IS REQUIRED)
	Updated with the latest version of the IECHost firmware
	Added the setting to let users pre-seek track 1 via job queue when dumping disks
	Program info is now included in log files generated when dumping disks
	Added "mass dumping" mode, for automatically naming D64 files when dumping disks

v2.14 - 06/09/2018 (FIRMWARE UPDATE TO VERSION 1.14 IS REQUIRED)
	Updated with the latest version of the IECHost firmware
	Let users customize disk name and ID for formatting and fast-formatting disks
	Added the setting to read the firmware version running on the device in use
	When dumping disks, comprehensive log files are now saved along with D64 files
	When dumping a disk whose name is blank, "NO NAME.D64" is the default PC filename suggested
	The directory listings can also be navigated using Home, End, Page Up and Page Down keyboard keys
	When dumping disks, a brighter red is used for sectors that fail the GCR decoding
	Directory listings protected with 0-byte values are now automatically unprotected

v2.13 - 03/09/2018
	The case when sector retry attempts are exhausted for a track is now correctly handled
	Whole menu groups are now disabled when a disk operation is in progress

v2.12 - 31/08/2018
	Enabled a number of key shortcuts for disk imaging and file handling
	Swapped around configuration/connection menu items
	Added drive code acknowledgements in the "About" dialog

v2.11 - 29/07/2018
	Fixed a bug that could have occurred when configuring the access port under Windows
	Added a feature to automatically reformat "COM##" to "\\.\COM##" under Windows
	Compiled with "-O3" again under Windows

v2.10 - 21/04/2018
	Added a mechanism to detect a missing track change request from the drive code

v2.9 - 05/04/2018
	Stricter sanitization of the suggested disk name when saving disk images
	Stricter sanitization of the suggested PRG name when exporting files
	The drive number selection is persisted across subsequent executions of the application
	The D64 and PRG folders are persisted across subsequent executions of the application
	The warning dialog is only displayed once per execution of the application

v2.8 - 29/03/2018
	Updated with the latest version of the IECHost firmware
	Added and rationalised a number of messages for advertising the current operation
	Added the Tools menu
	Added the setting to initialize a disk drive (through the "I0:" command)
	Added the setting to query the status message from a disk drive
	Added the setting to soft-reset a disk drive (through the "UJ:" command)
	Added the setting to fast format a disk using Daniel "tlr" Kahlin's "Format II" code

v2.7 - 17/02/2018
	Added the setting to set maximum sector read errors for Warp imaging of disks to D64 files

v2.6 - 16/02/2018
	Added the setting to set sector read retries for Warp imaging of disks to D64 files

v2.5 - 14/02/2018
	Added the website URL in the "About" dialog
	Reworded a few log and status bar messages

v2.4 - 13/02/2018
	Integrated the firmware module to ensure the most compatible firmware is used for updates

v2.3 - 13/02/2018
	The exit code from avrdude during a firmware update is now checked for success

v2.2 - 12/02/2018
	Added the version of gcc used to build the application in the "About" dialog
	Made a few code rationalisations
	Removed the compilation option "-O3" for Windows as it causes issues under Windows 10
	Disabled the communication port string reformatting as it causes issues under Windows 10

v2.1 - 10/02/2018
	Made a few code rationalisations
	Compiled with "-O3"

v2.0 - 09/02/2018
	Added a sector retry mechanism for when dumping disks
	Redesigned the sector grid update mechanism for disk imaging tasks
	Integrated my serial communication library for better maintainability
	Integrated my console library for better maintainability
	Added a few more logging messages
	The communication port string is reformatted under Windows, if required

v1.16 - 07/02/2018
	Added further file validation for the PRG import functionality

v1.15 - 23/01/2018
	Added further logging messages
	The secondary address is set to 1 when exporting PRG files

v1.14 - 26/06/2017
	Added the functionality to save D64 back to physical disks

v1.13 - 27/05/2017
	Added a progress bar for PRG exporting/importing

v1.12 - 17/05/2017
	Added PRG import, file scratch, disk validate, and disk format functionalities
	Added a confirmation dialog for tasks that modify disk contents

v1.11 - 15/05/2017
	Added extra log messages

v1.10 - 13/05/2017
	A disk's name is used as PC filename when saving it to D64
	A file's name is uded as PC filename when saving it to PRG

v1.9 - 13/05/2017
	Added logging to a separate tab

v1.8 - 11/05/2017
	Added the PRG exporting functionality

v1.7 - 11/05/2017
	Refactored GCR and Warp API into separate modules
	Added further error checking
	Implemented a few fixes for the communication channel under Linux
	Full implementation of the multi-threaded architecture

v1.6 - 09/05/2017
	Implemented the PETSCII display module
	Implemented the directory browsing module
	Implemented the BASIC listing module
	Moved the abort button to the status bar area

v1.5 - 06/05/2017
	Added File/Directory read functionalities
	Added a reset device menu option to facilitate the discovery of the bootloader port

v1.4 - 06/05/2017
	Initial implementation of a multi-threaded architecture

v1.3 - 02/05/2017
	Added the firmware update functionality
	Start with default port names

v1.2 - 21/04/2017
	Implemented the abort mechanism

v1.1 - 18/04/2017
	Completed the disk dumping functionality
	Added displaying of the total dumping time

v1.0 - 11/04/2017
	Initial development version for sector dumping
